//"procrw.sc","Procedury rezerwacji","\Procedury\",0,1.0.0,SYSTEM

	// uytkownicy upowanieni do kasowania nie swoich dostaw
	// nazwa uytkownika musi posiada z przodu i z tyu znak ;
	buf = ";Admin;DD;"

	dispatch con = GetAdoConnection()
	dispatch rs = "ADODB.RecordSet"
	
string sub CurrentUser()
	Dispatch App = GetApplication() 
	CurrentUser = App.PropertyAp("Current Login")	
endsub

string sub CzyjaRezerwacja(long lId)
	
	dispatch xRz
	int rzErr
	xRz = xFactory.NewObject("BRezerwacja") 
	rzErr = xRz.Load(using "id=%l",lId) 

	dispatch xDk
	string sObj

	if xRz.Typ == 1 then
		// dla rcznych rezerwacji sprawdzamy z naszej tabelki
		if rs.State == 1 then rs.Close()
		rs.Open((using "SELECT TOP 1 * FROM RZU WHERE id =%l ORDER BY czas desc", lId), con, 3,3)
		if rs.RecordCount() > 0 then
			CzyjaRezerwacja = rs.Fields("wlasciciel").Value
		endif
	else		
		// dla automatycznych rezerwacji sprawdzamy kto wystawi dokument
		select case xRz.bazadokrz
		case 16
			sObj = "BDokumentSp"
		case 33
			sObj = "BDokumentMg"		
		case 45
			sObj = "BDokumentZo"
		case else
			message using "Nie obsugiwany typ dokumentu : %l", xRz.bazadokrz
		endselect		
		// mam nadziej, e nic wicej nie rezerwuje

		xDk = xFactory.NewObject( sObj ) 
		xDk.Load(using "id=%l",xRz.iddokrz)

		CzyjaRezerwacja = xDk.osoba.kod
endif

	// jeeli uykownik jest w zmiennej buf to nie wane kto staje si waciecielem
	if find regular "^{*};"+CurrentUser()+";{*}$" then CzyjaRezerwacja = CurrentUser()

endsub

int sub UsunRZU( long lId )
	if rs.State == 1 then rs.Close()
	rs.Open((using "DELETE FROM RZU WHERE id =%l", lId), con, 3,3)		
endsub

int sub DodajWlasciciela(long lId, string sWl)
	if rs.State == 1 then rs.Close()
	rs.Open((using "INSERT INTO RZU (id,wlasciciel) VALUES (%l,'%s')", lId, sWl), con, 3,3)
endsub

int Sub OnAfterInsert(long lId)

	UsunRZU( lId )
	
	dispatch xRz
	int rzErr
	xRz = xFactory.NewObject("BRezerwacja") 
	rzErr = xRz.Load(using "id=%l",lId) 

	if xRz.Typ == 1 then
		DodajWlasciciela( lId, CurrentUser() )
	endif
	OnAfterInsert = 0
EndSub

int Sub OnBeforeDelete(long lId)
		if CzyjaRezerwacja( lId ) != CurrentUser() then
			message "Usun moe tylko waciciel rezerwacji."
			OnBeforeDelete = -6000			
		else
			OnBeforeDelete = 0
		endif
EndSub

int Sub OnAfterUpdate(long lId)
	OnAfterUpdate = 0
EndSub

int Sub OnBeforeEdit(long lId)
	if lId != 0 then
		if CzyjaRezerwacja( lId ) != CurrentUser() then
			message "Edytowa moe tylko waciciel rezerwacji."
			OnBeforeEdit = -6000			
		else
			OnBeforeEdit = 0
		endif
	endif
EndSub
